
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>git学习------&amp;gt;Git 分支管理最佳实践 / iVAN</title>

    <meta name="description" content="git学习------&amp;gt;Git 分支管理最佳实践 ps:本文转载于 : https://www.ibm.com/developerworks/cn/java/j-lo-git-mange/index.html Git 是目前最流行的源代码管理工具.大量的软件项目由 GitHub.Bitbucket 和 GitLab 这样的云服务平台或是私有的 Git 仓库来管理.在使用 Git 时通常会遇到的一个问题是采用何种分支管理实践,即如何管理仓库中作用不同的各类分支.和软件开发中的其他实践一样,Git 分支管理并没有普遍适用的最佳做法,而只有对每个团队">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">git学习------&amp;gt;Git 分支管理最佳实践</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>ps:本文转载于 ： <a href="https://www.ibm.com/developerworks/cn/java/j-lo-git-mange/index.html" rel="external nofollow noreferrer">https://www.ibm.com/developerworks/cn/java/j-lo-git-mange/index.html</a></p>
<p>Git 是目前最流行的源代码管理工具。大量的软件项目由 GitHub、Bitbucket 和 GitLab 这样的云服务平台或是私有的 Git 仓库来管理。在使用 Git 时通常会遇到的一个问题是采用何种分支管理实践，即如何管理仓库中作用不同的各类分支。和软件开发中的其他实践一样，Git 分支管理并没有普遍适用的最佳做法，而只有对每个团队和项目而言最适合的做法。简单来说，在项目开发中使用多个分支会带来额外的管理和维护开销，但是多个分支对于项目的团队合作、新功能开发和发布管理都是有一定好处的。不同的团队可以根据团队人员组成和意愿、项目的发布周期等因素选择最适合的策略，找到最适合团队的管理方式。本文将介绍三种常见的 Git 分支管理方式。</p>
<h2>单主干</h2>
<p>单主干的分支实践（Trunk-based development，TBD）在 SVN 中比较流行。<a href="http://paulhammant.com/2013/05/06/googles-scaled-trunk-based-development/" rel="external nofollow noreferrer">Google</a> 和 <a href="http://paulhammant.com/2013/03/13/facebook-tbd-take-2/" rel="external nofollow noreferrer">Facebook</a> 都使用这种方式。trunk 是 SVN 中主干分支的名称，对应到 Git 中则是 master 分支。TBD 的特点是所有团队成员都在单个主干分支上进行开发。当需要发布时，先考虑使用标签（tag），即 tag 某个 commit 来作为发布的版本。如果仅靠 tag 不能满足要求，则从主干分支创建发布分支。bug 修复在主干分支中进行，再 cherry-pick 到发布分支。图 1 是 TBD 中分支流程的示意图。</p>
<h5>图 1. TBD 中的分支流程的示意图</h5>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3d3dy5pYm0uY29tL2RldmVsb3BlcndvcmtzL2NuL2phdmEvai1sby1naXQtbWFuZ2UvaW1nMDAxLnBuZw==.jpg"><br />由于所有开发人员都在同一个分支上工作，团队需要合理的分工和充分的沟通来保证不同开发人员的代码尽可能少的发生冲突。持续集成和自动化测试是必要的，用来及时发现主干分支中的 bug。因为主干分支是所有开发人员公用的，一个开发人员引入的 bug 可能对其他很多人造成影响。不过好处是由于分支所带来的额外开销非常小。开发人员不需要频繁在不同的分支之间切换。</p>
<h2>GitHub flow</h2>
<p><a href="http://scottchacon.com/2011/08/31/github-flow.html" rel="external nofollow noreferrer">GitHub flow</a> 是 GitHub 所使用的一种简单的流程。该流程只使用两类分支，并依托于 GitHub 的 pull request 功能。在 GitHub flow 中，master 分支中包含稳定的代码。该分支已经或即将被部署到生产环境。master 分支的作用是提供一个稳定可靠的代码基础。任何开发人员都不允许把未测试或未审查的代码直接提交到 master 分支。</p>
<p>对代码的任何修改，包括 bug 修复、hotfix、新功能开发等都在单独的分支中进行。不管是一行代码的小改动，还是需要几个星期开发的新功能，都采用同样的方式来管理。当需要进行修改时，从 master 分支创建一个新的分支。新分支的名称应该简单清晰地描述该分支的作用。所有相关的代码修改都在新分支中进行。开发人员可以自由地提交代码和 push 到远程仓库。</p>
<p>当新分支中的代码全部完成之后，通过 GitHub 提交一个新的 pull request。团队中的其他人员会对代码进行审查，提出相关的修改意见。由持续集成服务器（如 Jenkins）对新分支进行自动化测试。当代码通过自动化测试和代码审查之后，该分支的代码被合并到 master 分支。再从 master 分支部署到生产环境。图 2 是 GitHub flow 分支流程的示意图。</p>
<h5>图 2. Github flow 中的分支流程的示意图</h5>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3d3dy5pYm0uY29tL2RldmVsb3BlcndvcmtzL2NuL2phdmEvai1sby1naXQtbWFuZ2UvaW1nMDAyLnBuZw==.jpg"><br />GitHub flow 的好处在于非常简单实用。开发人员需要注意的事项非常少，很容易形成习惯。当需要进行任何修改时，总是从 master 分支创建新分支。完成之后通过 pull request 和相关的代码审查来合并回 master 分支。GitHub flow 要求项目有完善的自动化测试、持续集成和部署等相关的基础设施。每个新分支都需要测试和部署，如果这些不能自动化进行，会增加开发人员的工作量，导致无法有效地实施该流程。这种分支实践也要求团队有代码审查的相应流程。</p>
<h2>git-flow</h2>
<p><a href="http://nvie.com/posts/a-successful-git-branching-model/" rel="external nofollow noreferrer">git-flow</a> 应该是目前流传最广的 Git 分支管理实践。git-flow 围绕的核心概念是版本发布（release）。因此 git-flow 适用于有较长版本发布周期的项目。虽然目前推崇的做法是持续集成和随时发布。有的项目甚至可以一天发布很多次。随时发布对于 SaaS 服务类的项目来说是很适合的。不过仍然有很大数量的项目的发布周期是几个星期甚至几个月。较长的发布周期可能是由于非技术相关的因素造成的，比如人员限制、管理层决策和市场营销策略等。</p>
<p>git-flow 流程中包含 5 类分支，分别是 master、develop、新功能分支（feature）、发布分支（release）和 hotfix。这些分支的作用和生命周期各不相同。master 分支中包含的是可以部署到生产环境中的代码，这一点和 GitHub flow 是相同的。develop 分支中包含的是下个版本需要发布的内容。从某种意义上来说，develop 是一个进行代码集成的分支。当 develop 分支集成了足够的新功能和 bug 修复代码之后，通过一个发布流程来完成新版本的发布。发布完成之后，develop 分支的代码会被合并到 master 分支中。</p>
<p>其余三类分支的描述如<a href="https://www.ibm.com/developerworks/cn/java/j-lo-git-mange/index.html#_%E8%A1%A8%201.%20git-flow%20%E5%88%86%E6%94%AF%E7%B1%BB%E5%9E%8B" rel="external nofollow noreferrer">表 1</a>所示。这三类分支只在需要时从 develop 或 master 分支创建。在完成之后合并到 develop 或 master 分支。合并完成之后该分支被删除。这几类分支的名称应该遵循一定的命名规范，以方便开发人员识别。</p>
<h5>表 1. git-flow 分支类型</h5>
<p><table>
<thead>
<tr>
<th>分支类型</th>
<th>命名规范</th>
<th>创建自</th>
<th>合并到</th>
<th>说明</th>
</tr>
</thead>
<tbody>
<tr>
<td>feature</td>
<td>feature/*</td>
<td>develop</td>
<td>develop</td>
<td>新功能</td>
</tr>
<tr>
<td>release</td>
<td>release/*</td>
<td>develop</td>
<td>develop 和 master</td>
<td>一次新版本的发布</td>
</tr>
<tr>
<td>hotfix</td>
<td>hotfix/*</td>
<td>master</td>
<td>develop 和 master</td>
<td>生产环境中发现的紧急 bug 的修复</td>
</tr>
</tbody>
</table>
<p>对于开发过程中的不同任务，需要在对应的分支上进行工作并正确地进行合并。每个任务开始前需要按照指定的步骤完成分支的创建。例如当需要开发一个新的功能时，基本的流程如下：</p>
<ul>
<li>从 develop 分支创建一个新的 feature 分支，如 feature/my-awesome-feature。</li>
<li>在该 feature 分支上进行开发，提交代码，push 到远端仓库。</li>
<li>当代码完成之后，合并到 develop 分支并删除当前 feature 分支。</li>
</ul>
<p>在进行版本发布和 hotfix 时也有类似的流程。当需要发布新版本时，采用的是如下的流程：</p>
<ul>
<li>从 develop 分支创建一个新的 release 分支，如 release/1.4。</li>
<li>把 release 分支部署到持续集成服务器上进行测试。测试包括自动化集成测试和手动的用户接受测试。</li>
<li>对于测试中发现的问题，直接在 release 分支上提交修改。完成修改之后再次部署和测试。</li>
<li>当 release 分支中的代码通过测试之后，把 release 分支合并到 develop 和 master 分支，并在 master 分支上添加相应的 tag。</li>
</ul>
<p>因为 git-flow 相关的流程比较繁琐和难以记忆，在实践中一般使用<a href="https://github.com/nvie/gitflow" rel="external nofollow noreferrer">辅助脚本</a>来完成相关的工作。比如同样的开发新功能的任务，可以使用 git flow feature start my-awesome-feature 来完成新分支的创建，使用 git flow feature finish my-awesome-feature 来结束 feature 分支。辅助脚本会完成正确的分支创建、切换和合并等工作。</p>
<h3>Maven JGit-Flow</h3>
<p>对于使用 Apache Maven 的项目来说，Atlassian 的 <a href="http://jgitflow.bitbucket.org/index.html" rel="external nofollow noreferrer">JGit-Flow</a> 是一个更好的 git-flow 实现。JGit-Flow 是一个基于 <a href="http://eclipse.org/jgit/" rel="external nofollow noreferrer">JGit</a> 的纯 Java 实现的 git-flow，并不需要安装额外的脚本，只需要作为 Maven 的插件添加到 Maven 项目中即可。JGit-Flow 同时可以替代 <a href="http://maven.apache.org/maven-release/maven-release-plugin/" rel="external nofollow noreferrer">Maven release 插件</a>来进行发布管理。JGit-Flow 会负责正确的设置不同分支中的 Maven 项目的 POM 文件中的版本，这对于 Maven 项目的构建和发布是很重要的。</p>
<p>在 Maven 项目的 pom.xml 文件中添加<a href="https://www.ibm.com/developerworks/cn/java/j-lo-git-mange/index.html#_%E6%B8%85%E5%8D%95%201.%20JGit-Flow%20%E7%9A%84%20Maven%20%E8%AE%BE%E7%BD%AE" rel="external nofollow noreferrer">代码清单</a><a href="https://www.ibm.com/developerworks/cn/java/j-lo-git-mange/index.html#_%E6%B8%85%E5%8D%95%201.%20JGit-Flow%20%E7%9A%84%20Maven%20%E8%AE%BE%E7%BD%AE" rel="external nofollow noreferrer">1</a>中的插件声明就可以使用 JGit-Flow。&lt;configuration&gt;中包含的是 JGit-Flow 不同任务的配置。</p>
<h5>清单 1. JGit-Flow 的 Maven 设置</h5>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14</p>
<p>15</p>
<p>16</p>
<p>17</p>
<p>18
</td>
<td>
<p><code>&lt;</code><code>build</code><code>&gt;</code></p>
<p><code>   </code><code>&lt;</code><code>plugins</code><code>&gt;</code></p>
<p><code>       </code><code>&lt;</code><code>plugin</code><code>&gt;</code></p>
<p><code>           </code><code>&lt;</code><code>groupId</code><code>&gt;external.atlassian.jgitflow&lt;/</code><code>groupId</code><code>&gt;</code></p>
<p><code>           </code><code>&lt;</code><code>artifactId</code><code>&gt;jgitflow-maven-plugin&lt;/</code><code>artifactId</code><code>&gt;</code></p>
<p><code>           </code><code>&lt;</code><code>version</code><code>&gt;1.0-m5.1&lt;/</code><code>version</code><code>&gt;</code></p>
<p><code>           </code><code>&lt;</code><code>configuration</code><code>&gt;</code></p>
<p><code>              </code><code>&lt;</code><code>flowInitContext</code><code>&gt;</code></p>
<p><code>                </code><code>&lt;</code><code>versionTagPrefix</code><code>&gt;release-&lt;/</code><code>versionTagPrefix</code><code>&gt;</code></p>
<p><code>              </code><code>&lt;/</code><code>flowInitContext</code><code>&gt;</code></p>
<p><code>               </code><code>&lt;</code><code>releaseBranchVersionSuffix</code><code>&gt;RC&lt;/</code><code>releaseBranchVersionSuffix</code><code>&gt;</code></p>
<p><code>               </code><code>&lt;</code><code>noDeploy</code><code>&gt;true&lt;/</code><code>noDeploy</code><code>&gt;</code></p>
<p><code>               </code><code>&lt;</code><code>allowSnapshots</code><code>&gt;true&lt;/</code><code>allowSnapshots</code><code>&gt;</code></p>
<p><code>               </code><code>&lt;</code><code>allowUntracked</code><code>&gt;true&lt;/</code><code>allowUntracked</code><code>&gt;</code></p>
<p><code>           </code><code>&lt;/</code><code>configuration</code><code>&gt;</code></p>
<p><code>       </code><code>&lt;/</code><code>plugin</code><code>&gt;</code></p>
<p><code>   </code><code>&lt;/</code><code>plugins</code><code>&gt;</code></p>
<p><code>&lt;/</code><code>build</code><code>&gt;</code></p>
</td>
</tr>
</tbody>
</table>
<p>JGit-Flow 提供了很多配置选项，可以在 POM 文件中声明。这些配置项可以对不同的任务生效。常用的配置项如<a href="https://www.ibm.com/developerworks/cn/java/j-lo-git-mange/index.html#_%E8%A1%A8%202.%20JGit-Flow%20%E7%9A%84%E9%85%8D%E7%BD%AE%E9%A1%B9" rel="external nofollow noreferrer">表</a><a href="https://www.ibm.com/developerworks/cn/java/j-lo-git-mange/index.html#_%E8%A1%A8%202.%20JGit-Flow%20%E7%9A%84%E9%85%8D%E7%BD%AE%E9%A1%B9" rel="external nofollow noreferrer">2</a> 所示。</p>
<h5>表 2. JGit-Flow 的配置项</h5>
<p><table>
<thead>
<tr>
<th>名称</th>
<th>描述</th>
<th>适用任务</th>
</tr>
</thead>
<tbody>
<tr>
<td>flowInitContext</td>
<td>配置不同类型的分支的名称</td>
<td>全局</td>
</tr>
<tr>
<td>allowSnapshots</td>
<td>是否允许存在 SNAPSHOT 类型的依赖</td>
<td> </td>
</tr>
<tr>
<td>allowUntracked</td>
<td>是否允许本地 Git 中存在未提交的内容</td>
<td> </td>
</tr>
<tr>
<td>scmCommentPrefix 和 scmCommentSuffix</td>
<td>JGit-Flow 会进行代码合并工作。通过这两个配置项来设置 JGit-Flow 进行代码提交时的消息的前缀和后缀</td>
<td>全局</td>
</tr>
<tr>
<td>username 和 password</td>
<td>进行 Git 认证时的用户名和密码，适用于 HTTPS 仓库</td>
<td>全局</td>
</tr>
<tr>
<td>releaseBranchVersionSuffix</td>
<td>release 分支中项目的 POM 文件版本号的后缀</td>
<td> </td>
</tr>
<tr>
<td>developmentVersion</td>
<td>下一个开发版本的版本号</td>
<td> </td>
</tr>
<tr>
<td>releaseVersion</td>
<td>发布版本的版本号</td>
<td> </td>
</tr>
<tr>
<td>pushReleases</td>
<td>是否把 release 分支 push 到远程仓库</td>
<td> </td>
</tr>
<tr>
<td>goals</td>
<td>当部署发布版本到 Maven 仓库时执行的目标</td>
<td>release-finish，hotfix-finish</td>
</tr>
<tr>
<td>keepBranch</td>
<td>当发布完成之后是否保留相应的分支</td>
<td>release-finish，hotfix-finish</td>
</tr>
<tr>
<td>noDeploy</td>
<td>是否启用部署到 Maven 仓库的功能</td>
<td>release-finish，hotfix-finish</td>
</tr>
<tr>
<td>noReleaseBuild</td>
<td>在完成发布时是否禁用 Maven 构建</td>
<td>release-finish</td>
</tr>
<tr>
<td>noReleaseMerge</td>
<td>在完成发布时是否把 release 分支合并回 develop 和 master 分支</td>
<td>release-finish</td>
</tr>
<tr>
<td>noTag</td>
<td>在完成发布时是否添加标签</td>
<td>release-finish，hotfix-finish</td>
</tr>
<tr>
<td>squash</td>
<td>在进行分支合并时，是否把多个 commit 合并成一个</td>
<td>release-finish，hotfix-finish</td>
</tr>
<tr>
<td>featureName</td>
<td>新特性分支的名称</td>
<td>feature-start，feature-finish，feature-deploy</td>
</tr>
<tr>
<td>pushFeatures</td>
<td>是否把特性分支 push 到远程仓库</td>
<td>feature-start，feature-finish</td>
</tr>
<tr>
<td>noFeatureBuild</td>
<td>在完成特性时是否禁用 Maven 构建</td>
<td>feature-finish</td>
</tr>
<tr>
<td>noFeatureMerge</td>
<td>在完成特性时是否把特性分支合并回 develop</td>
<td>feature-finish</td>
</tr>
<tr>
<td>pushHotfixes</td>
<td>在完成 hotfix 时是否把分支合并回 master</td>
<td>hotfix-finish</td>
</tr>
<tr>
<td>noHotfixBuild</td>
<td>在完成 hotfix 时是否禁用 Maven 构建</td>
<td>hotfix-finish</td>
</tr>
</tbody>
</table>
<p>其余的配置项可以参考插件不同任务的<a href="https://bitbucket.org/atlassian/jgit-flow/wiki/goals.wiki" rel="external nofollow noreferrer">文档</a>。</p>
<p>在启用了 JGit-Flow 之后，可以通过 mvn 运行 jgitflow:feature-start 和 jgitflow:feature-finish 来开始和结束新特性的开发。与版本发布和 hotfix 相关的命令分别是 jgitflow:release-start 和 jgitflow:release-finish 以及 jgitflow:hotfix-start 和 jgitflow:hotfix-finish。在运行命令之后，JGit-Flow 会完成相关的 Git 分支创建、合并、删除、添加 tag 等操作，不需要开发人员手动完成。</p>
<p>每个分支的 pom.xml 中的版本号的格式并不相同。如 master 分支的版本号是标准的发布版本号，如 1.2.3；develop 分支中则是 SNAPSHOT 版本，比 master 分支的版本号要高，如 1.2.4-SNAPSHOT；release 分支可以通过&lt;releaseBranchVersionSuffix&gt;配置来指定版本号的后缀，如 1.2.3-RC-SNAPSHOT；feature 分支可以通过&lt;enableFeatureVersions&gt;配置来把 feature 分支名称作为后缀添加到版本号中，如 1.2.3-my-awesome-feature-SNAPSHOT；hotfix 分支的版本号基于 master 分支的版本号，如 1.2.3.1 是对于 1.2.3 版本的第一个 hotfix。当使用 jgitflow:release-finish 完成一个 release 分支时，develop 分支的版本号会被自动更新成下一个小版本，如从 1.2.3 到 1.2.4。当需要手动修改版本号时，可以使用 <a href="http://mojo.codehaus.org/versions-maven-plugin/" rel="external nofollow noreferrer">Versions 插件</a>，如 mvn versions:set -DnewVersion=2.0.0-SNAPSHOT。</p>
<p><strong>持续集成</strong></p>
<p>由于 JGit-Flow 是纯 Java 的 Maven 插件实现，可以很容易的与常用的持续集成服务器进行集成。不过在与 Atlassian 的 Bamboo 集成时，有几个细节需要注意。首先是 Bamboo 在进行构建的时候，使用的是一个虚拟的 Git 仓库，其仓库地址是一个不存在的文件系统路径。因此需要在 JGit-Flow 的配置中手动设置 Git 仓库的地址，保证 Git 操作可以正确执行，如<a href="https://www.ibm.com/developerworks/cn/java/j-lo-git-mange/index.html#_%E6%B8%85%E5%8D%95%202.%20%E6%89%8B%E5%8A%A8%E8%AE%BE%E7%BD%AE%20JGit-Flow%20%E7%9A%84%20Git%20%E4%BB%93%E5%BA%93%E5%9C%B0%E5%9D%80" rel="external nofollow noreferrer">代码清单</a><a href="https://www.ibm.com/developerworks/cn/java/j-lo-git-mange/index.html#_%E6%B8%85%E5%8D%95%202.%20%E6%89%8B%E5%8A%A8%E8%AE%BE%E7%BD%AE%20JGit-Flow%20%E7%9A%84%20Git%20%E4%BB%93%E5%BA%93%E5%9C%B0%E5%9D%80" rel="external nofollow noreferrer">2</a>所示。</p>
<h5>清单 2. 手动设置 JGit-Flow 的 Git 仓库地址</h5>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4
</td>
<td>
<p><code>&lt;</code><code>configuration</code><code>&gt;</code></p>
<p><code>   </code><code>&lt;</code><code>defaultOriginUrl</code><code>&gt;[Git url]&lt;/</code><code>defaultOriginUrl</code><code>&gt;</code></p>
<p><code>   </code><code>&lt;</code><code>alwaysUpdateOrigin</code><code>&gt;true&lt;/</code><code>alwaysUpdateOrigin</code><code>&gt;</code></p>
<p><code>&lt;/</code><code>configuration</code><code>&gt;</code></p>
</td>
</tr>
</tbody>
</table>
<p>另外在开始新的 release 之前，需要确保前一个发布分支已经被删除。JGit-Flow 在默认情况下会自动在发布完成之后，删除对应的 Git 分支。但是可能本地仓库中还保留有之前的发布分支，这会导致新的 release-start 任务执行失败。一种解决方式是每次都重新 checkout 新的仓库，这样可以保证不会出现已经在远程被删除的分支。不过可能会增加构建的时间。另外一种解决方式是通过 Git 命令来删除本地分支，如<a href="https://www.ibm.com/developerworks/cn/java/j-lo-git-mange/index.html#_%E6%B8%85%E5%8D%95%203.%20%E5%88%A0%E9%99%A4%20Git%20%E6%9C%AC%E5%9C%B0%E5%88%86%E6%94%AF" rel="external nofollow noreferrer">代码清单</a><a href="https://www.ibm.com/developerworks/cn/java/j-lo-git-mange/index.html#_%E6%B8%85%E5%8D%95%203.%20%E5%88%A0%E9%99%A4%20Git%20%E6%9C%AC%E5%9C%B0%E5%88%86%E6%94%AF" rel="external nofollow noreferrer">3</a>所示。</p>
<h5>清单 3. 删除 Git 本地分支</h5>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8
</td>
<td>
<p><code>${bamboo.capability.system.git.executable} fetch --prune --verbose</code></p>
<p> </p>
<p><code>${bamboo.capability.system.git.executable} branch -vv | awk '/: gone]/{print $1}' | </code></p>
<p><code>                      </code><code>xargs ${bamboo.capability.system.git.executable} branch -d 2&gt; /dev/null</code></p>
<p> </p>
<p><code>echo 'stale branches deleted'</code></p>
<p> </p>
<p><code>Git 分支合并冲突处理</code></p>
</td>
</tr>
</tbody>
</table>
<p>当把发布分支合并到 develop 时，可能会出现冲突。因为在发布分支中有与 bug fix 相关的改动，在 develop 分支中有可能修改相同的文件。当有冲突时，直接运行 JGit-Flow 的 release-finish 任务会出错。这个时候需要开发人员手动把发布分支合并到 develop 分支，并解决相应的冲突。然后再次运行 release-finish 任务即可。</p>
<h2>选择合适的实践</h2>
<p>每个开发团队都应该根据团队自身和项目的特点来选择最适合的分支实践。首先是项目的版本发布周期。如果发布周期较长，则 git-flow 是最好的选择。git-flow 可以很好地解决新功能开发、版本发布、生产系统维护等问题；如果发布周期较短，则 TBD 和 GitHub flow 都是不错的选择。GitHub flow 的特色在于集成了 pull request 和代码审查。如果项目已经使用 GitHub，则 GitHub flow 是最佳的选择。GitHub flow 和 TBD 对持续集成和自动化测试等基础设施有比较高的要求。如果相关的基础设施不完善，则不建议使用。</p>
<h2>小结</h2>
<p>Git 作为目前最流行的源代码管理工具，已经被很多开发人员所熟悉和使用。在基于 Git 的团队开发中，Git 分支的作用非常重要，可以让团队的不同成员同时在多个相对独立的特性上工作。本文对目前流行的 3 种 Git 分支管理实践做了介绍，并着重介绍了 git-flow 以及与之相关的 Maven JGit-Flow 插件。</p>
<h4>相关主题</h4>
<ul>
<li>了解 <a href="http://paulhammant.com/2013/05/06/googles-scaled-trunk-based-development/" rel="external nofollow noreferrer">Google</a> 和 <a href="http://paulhammant.com/2013/03/13/facebook-tbd-take-2/" rel="external nofollow noreferrer">Facebook</a> 的单主干实践。</li>
<li>了解 <a href="http://scottchacon.com/2011/08/31/github-flow.html" rel="external nofollow noreferrer">GitHub flow</a> 的更多内容。</li>
<li>了解 <a href="http://nvie.com/posts/a-successful-git-branching-model/" rel="external nofollow noreferrer">git-flow</a> 的更多内容。</li>
<li>了解 Maven <a href="http://jgitflow.bitbucket.org/index.html" rel="external nofollow noreferrer">JGit-Flow</a> 插件的更多内容。</li>
<li><a href="http://www.ibm.com/developerworks/cn/java/" rel="external nofollow noreferrer">developerWorks Java 技术专区</a>：这里有数百篇关于 Java 编程各个方面的文章。</li>
</ul>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 08:46:50</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%b5%8b%e8%af%95/" title="测试">测试</a>, <a href="https://www.iamivan.net/tag/%e6%8f%92%e4%bb%b6/" title="插件">插件</a>, <a href="https://www.iamivan.net/tag/%e9%85%8d%e7%bd%ae/" title="配置">配置</a>, <a href="https://www.iamivan.net/tag/maven/" title="Maven">Maven</a>, <a href="https://www.iamivan.net/tag/github/" title="github">github</a>, <a href="https://www.iamivan.net/tag/%e8%87%aa%e5%8a%a8%e5%8c%96%e6%b5%8b%e8%af%95/" title="自动化测试">自动化测试</a>, <a href="https://www.iamivan.net/tag/%e6%8c%81%e7%bb%ad%e9%9b%86%e6%88%90/" title="持续集成">持续集成</a>, <a href="https://www.iamivan.net/tag/git/" title="git">git</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>git学习------&amp;gt;Git 分支管理最佳实践的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQ971Wb.html" rel="bookmark">混合云模型管理最佳实践五大要点</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				对于认证考虑采用混合云模型的企业而言,其实现必须有计划,以便IT人员能够和现有私有云一样精准的进行管理.下面,我们给出了管理混合云的方式,假设IT团队遵循了企业ITIL最佳实践. 不管你如何小心的选择公有云服务,而且和你的私有云设计匹配的多么好,差异还是不可避免的存在.两个云之间的区别越大,就越难作为单一的实体管理这两个云.也会得到尽可能的延伸你的现有混合云管理战略和最佳实践的最大收获. 混合云管理战略应该涉及到下面的这些领域: 配置.IT团队必须细化创建.修改.不定和实现云安装的最佳实践.版本			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mg0Re1p.html" rel="bookmark">Android 6&period;0 权限管理最佳实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  博客: Android 6.0 运行时权限管理最佳实践 github: https://github.com/yanzhenjie/AndPermission  			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8kAYZM.html" rel="bookmark">【git学习】git管理本地项目</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				(转载请注明出处:http://blog.csdn.net/buptgshengod) 1.背景        最近打算使用git管理本地的项目,网上的资料很多,但是很杂,这这整理一下. 2.git使用 (1)初始化 新建一个git文件夹,cd进去,建立代码仓库 git init            进入该文件夹,将文件显示隐藏可见,里面会生成.git文件,如下图 将需要被管理的项目放到这个git文件夹下,或者从服务器clone需要的项目.我将testDraft放了进去 这时候输入以下命令,查			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmRPlaz.html" rel="bookmark">git常用操作和分支管理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				菜鸟教程 菜鸟教程有最基本的操作. 创建分支命令: git branch (branchname) 切换分支命令: git checkout (branchname) 当你切换分支的时候,Git 会用该分支的最后提交的快照替换你的工作目录的内容, 所以多个分支不需要多个目录. 合并分支命令: git merge 列出分支基本命令: git branch 没有参数时,git branch 会列出你在本地的分支. 删除分支命令: git branch -d (branchname) 一旦某分支有了独			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mrqe8jb.html" rel="bookmark">给大家推荐一本学习Web Service开发的最佳实践教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 给大家推荐一本学习WebService开发的最佳实践教程.CSDN上传不了,PDF版下载地址http://down.51cto.com/data/265669 解决方案 解决方案二:现在不用下载了,这个地址可以看书的视频http://school.itzcn.com/special-spid-60.html解决方案三:下载下来的内容不全啊,才两章解决方案四:该回复于2011-12-23 09:05:24被版主删除解决方案五:你发不我的箱邮吧.ADDR:[email=c_oo_p@sin			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MyggEZz.html" rel="bookmark">Mesos&plus;Zookeeper&plus;Marathon&plus;Docker分布式集群管理最佳实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				目录  Mesos简介 Zookeeper简介 Marathon简介 docker集群实践 Mesos集群部署   一.Mesos简介   Mesos是Apache下的开源分布式资源管理框架,它被称为分布式系统的内核.Mesos最初是由加州大学伯克利分校的AMPLab开发,后在Twitter得到广泛使用.   Mesos-Master:主要负责管理各个framework和slave,并将slave上的资源分配给各个framework. Mesos-Slave:负责管理本节点上的各个mesos-t			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEKD83p.html" rel="bookmark">git学习------&amp;amp&semi;gt&semi;git commit命令的默认编辑器的修改</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				   今天在新同事的电脑上,用git commit命令帮新同事提交代码的时候,编辑完commit的信息后,居然不记得怎么退出了.蛋疼. 后来百度了一下,原来此时是进入GUN nano编辑器.在这里可以添加你的commit imformation 然后ctrl+o,回车保存,再ctrl+x退出.好吧,我完全不习惯,因为我电脑上配置的默认编辑器是VIM.         现在把git commit的编辑器改回到VIM. 方法一.直接敲命令:git config –global core.editor			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkZ805M.html" rel="bookmark">权限管理最佳实践：二，URL权限控制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 原文地址:http://www.javaeye.com/topic/754014摘要:今天说的URL权限控制,内容主要有:URL权限控制,当用户访问某URL时,进行角色权限验证.如果有相应权限,则允许其正常访问:否则,转到拒绝页面.我们依然通过一个Filter来实现,这样就无需在代码中增加权限判断,也无需套用任何框架.对于整个权限管理系统来说,本节内容也非常简单. 解决方案 解决方案二:每个用户访问一个连接都去判断会不会影响性能解决方案三:权限不应该按照URL来划分,而应该按照功能来划			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBYyNAz.html" rel="bookmark">权限管理最佳实践：三&amp;amp&semi;amp&semi;amp&semi;四，数据级权限管理方案探讨</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 内容比较多,也有不少代码,粘贴过来太累了.感兴趣的点击下面链接: 解决方案 解决方案二:感谢分享!解决方案三:好东西...解决方案四:lz大哥,给我介绍一下,你推荐的这个都有哪些优点,缺点,这个目前怎么样,火不,用的人多吗?解决方案五:我点击超链为啥是404呢真相呢天理呢?解决方案六:我点击后的效果和4楼的效果是一样一样的!解决方案七:我和5楼一样解决方案八:demo好像特别卡解决方案九:点击看不了,什么原因?			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vMNJkdM.html" rel="bookmark" class="title">第二节 定义本地站点</a>
					<div>
						站点 用Dreamweaver制作网页,为了以后的方便,最好首先定义一个本地站点.其实,使用网页编辑器比起直接手写代码最大的优势就在于站点管理.用Dreamweaver,可以很方便的对站点内文件进行该 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnxmEkb.html" rel="bookmark" class="title">Oracle基于用户管理的不完全恢复（四）完全恢复时丢失部分归档日志</a>
					<div>
						案例3--在做完全恢复时,丢失了部分归档日志 (recover database until cancel;) 1.基于cancel 的不完全恢复 --模拟环境 SQL&gt; col table_n ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvK686p.html" rel="bookmark" class="title">iOS开发中的单元测试（二） 让断言活泼起来的匹配引擎</a>
					<div>
						上一篇文章简单介绍了OCUnit和GHUnit两款iOS开发中较为常见的单元测试框架,本文进一步介绍单元测试 中的另一利器--匹配引擎(Matcher Engine).匹配引擎可以替代断言方法,配合单 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJ7Gvvb.html" rel="bookmark" class="title">LINQ to SQL语句&lpar;21&rpar;之用户定义函数</a>
					<div>
						用户定义函数 我们可以在LINQ to SQL中使用用户定义函数.只要把 用户定义函数拖到O/R设计器中,LINQ to SQL自动使用FunctionAttribute属性 和ParameterAt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd7g6dM.html" rel="bookmark" class="title">PhotoShop给印度美女美白肤色的技巧</a>
					<div>
						原图 效果 三联推荐:photoshop7.0迷你版免费下载    |  Photoshop CS5 中文免费下载  |  photoshop免费下载   查看更多PS教程 详细教程 1.打开原图,添 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd6RE3b.html" rel="bookmark" class="title">Excel工作表打印线去除方法</a>
					<div>
						我们在经常会遇到Excel工作表打印后,会留有几条虚线打印线.如下图所示: 不少同学反映,他们尝试了很多操作却仍然无法消除.难道除了重新打开就没有别的办法了? 可以这样做: 在 Excel 2010  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWXGZqp.html" rel="bookmark" class="title">jquery实现下拉菜单的二级联动利用json对象从DB取值显示联动</a>
					<div>
						 这篇文章主要介绍了jquery实现下拉菜单的二级联动利用json对象从DB取值显示联动,需要的朋友可以参考下 利用struts2和Ajax实现json对象的传输,然后实现菜单的二级联动    下面是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8aaYb.html" rel="bookmark" class="title">Win8&period;1 Update&OpenCurlyDoubleQuote;应用&rdquo;视图如何显示更多磁贴</a>
					<div>
						  那如何开启该功能,让大屏显示器显示更多的磁贴应用? 测试平台:Win8.1 Update(17031)版本 具体操作如下: 1.打开开始屏幕,使用Win+i组合键(或者将鼠标指向屏幕右下角),调出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5oJWmb.html" rel="bookmark" class="title">httpwatch在IE11上的使用</a>
					<div>
						问题描述 httpwatch在IE11上的使用 为什么原本能打开的本地网页,一旦启用httpwatch之后就显示找不到该网页? 解决方案 使用jQuery判断IE11 解决方案二: 是这个样子的					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZEXy6p.html" rel="bookmark" class="title">select、poll、epoll之间的区别总结&lbrack;整理&rsqb;</a>
					<div>
						select,poll,epoll都是IO多路复用的机制.I/O多路复用就通过一种机制,可以监视多个描述符,一旦某个描述符就绪(一般是读就绪或者写就绪),能够通知程序进行相应的读写操作.但select ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NrPyM.html" rel="bookmark" class="title">请问环信支持消息加解密处理吗？</a>
					<div>
						问题描述 我现在想自己对消息进行加解密处理.比如在发送消息时,首先加密消息,然后再发送:接受时,先解密消息,然后显示到界面上.另外,是否可以在用户刚登录时,对离线消息进行解密,然后再显示到界面上?谢谢 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MA75LJz.html" rel="bookmark" class="title">源代码-ccf 模板生成问题 求答案求答案</a>
					<div>
						问题描述 ccf 模板生成问题 求答案求答案 成成最近在搭建一个网站,其中一些页面的部分内容来自数据库中不同的数据记录,但是页面的基本结构是相同的.例如,对于展示用户信息的页面,当用户为 Tom 时, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJAr5qp.html" rel="bookmark" class="title">ejb jboss7-Jboss7  里面 com&period;sun&period;proxy&period;&dollar;Proxy0 cannot be cast to com&period;ejb&period;impl&period;HelloWorldImpl</a>
					<div>
						问题描述 Jboss7 里面 com.sun.proxy.$Proxy0 cannot be cast to com.ejb.impl.HelloWorldImpl Hashtable jndiPro ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKqKAz.html" rel="bookmark" class="title">Oracle RAC 连接到指定实例</a>
					<div>
						        在某些特定的情形下,有时候需要从客户端连接到RAC中指定的实例,而不是由客户端Load_balance来动态选择或者是通过服务器端的监听器根据负载情形来转发.对此我们可以通过为tnsn ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRDo5Bz.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;菜鸟网络&rdquo;</a>
					<div>
						  昨天(9月3日),菜鸟网络召开第一次员工大会.菜鸟网络董事长兼阿里集团董事局主席马云在会上表示,阿里集团目前已将阿里物流业务整合至独立的物流公司&quot;菜鸟网络&quot;. 这条信息是由新浪 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNjZEdM.html" rel="bookmark" class="title">2015年，巨头将如何布局？</a>
					<div>
						2014年的科技界热闹非凡,可穿戴设备.智能家居和O2O的崛起吸引了大批投资,风投和并购金额屡创新高.科技行业是变化最快,公司寿命最短,竞争最残酷的行业,数十年基业千亿市值可以瞬间灰飞烟灭.对于科技巨 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjRkrM.html" rel="bookmark" class="title">有没有搞车联网后台的可以交流一下啊，好艰难，呜呜，求交流</a>
					<div>
						问题描述 有没有搞车联网后台的可以交流一下啊,好艰难 解决方案 解决方案二:你是在什么平台上开发的啊?现在除了GIS平台,其他的用C++的比较少.解决方案三:Linux下,因为我是中途插进来的,所以都 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBg5mKM.html" rel="bookmark" class="title">聚焦于战略性新兴产业领域</a>
					<div>
						他们有一个形象的名字金种子.他们诞生于去年12月,在全国关注小微企业发展,北京转变经济发展方式的大背景下,他们来得及时,来得令人惊喜.他们从中关村的2万家企业中精挑细选,他们定位于高科技,他们聚焦于战 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNnPD7M.html" rel="bookmark" class="title">支持B&sol;S架构吗？</a>
					<div>
						问题描述 **支持B/S架构吗?** 解决方案 环信支持WebIM.即基于浏览器的IM,类似微信网页版.并且环信的WebIM是完全开源的,非常方便开发者把WebIM集成到自己的web页面中,完全替换成 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAE4nAM.html" rel="bookmark" class="title">个推发布2&period;0产品 Smart Push</a>
					<div>
						摘要: 个推现在每天向用户分发8亿条消息,但他们却觉得推送得太多了,未来的推送应该是在合适的时间.合适的场景把合适的内容推送给合适的人.今天,个推在GMIC大会上发布了他们即将 个推现在每天向用户分发 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLkOLM.html" rel="bookmark" class="title">我想查询每个表中的数据有多少？</a>
					<div>
						问题描述 select a.talname,count(1) from (SELECT distinct 'ysj.'||table_name talname from all_tab_cols wh ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk0G4wz.html" rel="bookmark" class="title">三星Note Edge行货将上市 售价高达6899元</a>
					<div>
						DoNews 11月27日消息(记者 薛飞)来自于http://www.aliyun.com/zixun/aggregation/31646.html&quot;&gt;媒体报道的消息,与三星Gala ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1Nj7op.html" rel="bookmark" class="title">MySQL查询优化&colon;LIMIT 1避免全表扫描提高查询效率&lowbar;Mysql</a>
					<div>
						在某些情况下,如果明知道查询结果只有一个,SQL语句中使用LIMIT 1会提高查询效率. 例如下面的用户表(主键id,邮箱,密码): 复制代码 代码如下: create table t_user( i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z44xAqz.html" rel="bookmark" class="title">智能侵检测系统有前途吗？</a>
					<div>
						问题描述 我到国外读书,分到课题是智能入侵检测系统,其实就是用一些数据挖掘算法将入侵的信息里面一些特点挖掘出来,然后根据这些判断网络数据包是不是入侵,不知道这个前景怎么样?大家有什么高见还望指教下.. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgE7a5z.html" rel="bookmark" class="title">Struts2中checkboxlist怎么换行？   求代码</a>
					<div>
						问题描述 如题&lt;s:checkboxlistname=&quot;selectModules&quot;labelposition=&quot;top&quot;list=&quot;allFu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj8OLmp.html" rel="bookmark" class="title">网站上线之前需要检查的13个问题</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 废话少说: 1.用了Google分 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlAOQnp.html" rel="bookmark" class="title">c&num;使用student类输出学号姓名</a>
					<div>
						问题描述 c#使用student类输出学号姓名 为什么会输出 proj5-8.student? 我写的代码: using System; using System.Collections.Generi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOW8P9z.html" rel="bookmark" class="title">与传统商务相比下的电子商务</a>
					<div>
						如今的市场已今非昔比,传统商务被电子商务大潮所冲击,与传统商务相比,电子商务有哪些优缺点呢? 电子商务具有以下这些传统商务所无法比拟的优点: 1. 地域.时空优势 传统商务固定地点.固定时段销售;电子 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJeYl4p.html" rel="bookmark" class="title">外资电商多派系逐鹿快递市场</a>
					<div>
						外资.电商多派系逐鹿快递市场 本报讯 (记者索冬冬)随着部分外资快递和电子商务企业陆续申请经营快递业务许可,快递市场的竞争再度升温.今日,联邦快递和UPS两家公司申请经营国内快递业务许可公示到期.有分 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZmQRYp.html" rel="bookmark" class="title">关掉最讨厌的开关键&mdash;&mdash;乔布斯</a>
					<div>
						导读 : 乔布斯曾经这样在&lt;乔布斯传&gt;里自述过:&quot;我愿意这样认为,当一个人死后可能会有些什么东西依然存在.不过,在另一方面,可能就像个开关一样.&quot;他说,&quot;啪! ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.041 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
